﻿//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated from a template.
//
//     Manual changes to this file may cause unexpected behavior in your application.
//     Manual changes to this file will be overwritten if the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace Tech.Net.DataService
{
    using System;
    using System.Data.Entity;
    using System.Data.Entity.Infrastructure;
    using System.Data.Entity.Core.Objects;
    using System.Linq;
    
    public partial class TechNetDBEntities : DbContext
    {
        public TechNetDBEntities()
            : base("name=TechNetDBEntities")
        {
        }
    
        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            throw new UnintentionalCodeFirstException();
        }
    
        public virtual DbSet<Location> Locations { get; set; }
        public virtual DbSet<SpatialObject> SpatialObjects { get; set; }
        public virtual DbSet<SpatialObjectDocument> SpatialObjectDocuments { get; set; }
        public virtual DbSet<SpatialObjectReadModel> SpatialObjectReadModels { get; set; }
    
        public virtual ObjectResult<Nullable<double>> sp_GetGeographyDistance(Nullable<double> fromLatitude, Nullable<double> fromLongitude, Nullable<double> toLatitude, Nullable<double> toLongitude)
        {
            var fromLatitudeParameter = fromLatitude.HasValue ?
                new ObjectParameter("FromLatitude", fromLatitude) :
                new ObjectParameter("FromLatitude", typeof(double));
    
            var fromLongitudeParameter = fromLongitude.HasValue ?
                new ObjectParameter("FromLongitude", fromLongitude) :
                new ObjectParameter("FromLongitude", typeof(double));
    
            var toLatitudeParameter = toLatitude.HasValue ?
                new ObjectParameter("ToLatitude", toLatitude) :
                new ObjectParameter("ToLatitude", typeof(double));
    
            var toLongitudeParameter = toLongitude.HasValue ?
                new ObjectParameter("ToLongitude", toLongitude) :
                new ObjectParameter("ToLongitude", typeof(double));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<Nullable<double>>("sp_GetGeographyDistance", fromLatitudeParameter, fromLongitudeParameter, toLatitudeParameter, toLongitudeParameter);
        }
    }
}
